std::poisson_distribution< _IntType > Class Template Reference
Numerics » Random Number Generation » Random Number Distributions » Poisson Distributions

`#include <random>`

## Classes

struct | param_type

## Public Types

typedef _IntType | result_type

## Public Member Functions

| poisson_distribution (const param_type &__p)
| poisson_distribution (double __mean)
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>
void | __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng)
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>
void | __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
template<typename _UniformRandomNumberGenerator>
void | __generate (result_type *__f, result_type *__t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
result_type | max () const
double | mean () const
result_type | min () const
template<typename _UniformRandomNumberGenerator>
result_type | operator() (_UniformRandomNumberGenerator &__urng)
template<typename _UniformRandomNumberGenerator>
result_type | operator() (_UniformRandomNumberGenerator &__urng, const param_type &__p)
param_type | param () const
void | param (const param_type &__param)
void | reset ()

## Friends

template<typename _IntType1, typename _CharT, typename _Traits>
std::basic_ostream< _CharT, _Traits > & | operator<< (std::basic_ostream< _CharT, _Traits > &__os, const std::poisson_distribution< _IntType1 > &__x)
bool | operator== (const poisson_distribution &__d1, const poisson_distribution &__d2)
template<typename _IntType1, typename _CharT, typename _Traits>
std::basic_istream< _CharT, _Traits > & | operator>> (std::basic_istream< _CharT, _Traits > &__is, std::poisson_distribution< _IntType1 > &__x)

## Detailed Description

template<typename _IntType = int>
class std::poisson_distribution< _IntType >

A discrete Poisson random number distribution.

The formula for the Poisson probability density function is where is the parameter of the distribution.

Since
  C++11

Definition at line 4551 of file random.h.

## Member Typedef Documentation

## result_type

template<typename _IntType = int>

typedef _IntType std::poisson_distribution< _IntType >::result_type

The type of the range of the distribution.

Definition at line 4558 of file random.h.

## Constructor & Destructor Documentation

## poisson_distribution() [1/3]

template<typename _IntType = int>

std::poisson_distribution< _IntType >::poisson_distribution | ( |  | ) |

inline

Definition at line 4605 of file random.h.

## poisson_distribution() [2/3]

template<typename _IntType = int>

std::poisson_distribution< _IntType >::poisson_distribution | ( | double | __mean | ) |

inline explicit

Definition at line 4608 of file random.h.

## poisson_distribution() [3/3]

template<typename _IntType = int>

std::poisson_distribution< _IntType >::poisson_distribution | ( | const param_type & | __p | ) |

inline explicit

Definition at line 4613 of file random.h.

## Member Function Documentation

## __generate() [1/3]

template<typename _IntType = int>
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>

void std::poisson_distribution< _IntType >::__generate | ( | _ForwardIterator | __f,
|  | _ForwardIterator | __t,
|  | _UniformRandomNumberGenerator & | __urng )

inline

Definition at line 4676 of file random.h.

## __generate() [2/3]

template<typename _IntType = int>
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>

void std::poisson_distribution< _IntType >::__generate | ( | _ForwardIterator | __f,
|  | _ForwardIterator | __t,
|  | _UniformRandomNumberGenerator & | __urng,
|  | const param_type & | __p )

inline

Definition at line 4683 of file random.h.

## __generate() [3/3]

template<typename _IntType = int>
template<typename _UniformRandomNumberGenerator>

void std::poisson_distribution< _IntType >::__generate | ( | result_type * | __f,
|  | result_type * | __t,
|  | _UniformRandomNumberGenerator & | __urng,
|  | const param_type & | __p )

inline

Definition at line 4690 of file random.h.

## max()

template<typename _IntType = int>

result_type std::poisson_distribution< _IntType >::max | ( |  | ) | const

inline

Returns the least upper bound value of the distribution.

Definition at line 4657 of file random.h.

## mean()

template<typename _IntType = int>

double std::poisson_distribution< _IntType >::mean | ( |  | ) | const

inline

Returns the distribution parameter `mean`.

Definition at line 4628 of file random.h.

## min()

template<typename _IntType = int>

result_type std::poisson_distribution< _IntType >::min | ( |  | ) | const

inline

Returns the greatest lower bound value of the distribution.

Definition at line 4650 of file random.h.

## operator()() [1/2]

template<typename _IntType = int>
template<typename _UniformRandomNumberGenerator>

result_type std::poisson_distribution< _IntType >::operator() | ( | _UniformRandomNumberGenerator & | __urng | ) |

inline

Generating functions.

Definition at line 4665 of file random.h.

Referenced by operator()().

## operator()() [2/2]

template<typename _IntType>
template<typename _UniformRandomNumberGenerator>

poisson_distribution< _IntType >::result_type std::poisson_distribution< _IntType >::operator() | ( | _UniformRandomNumberGenerator & | __urng,
|  | const param_type & | __param )

A rejection algorithm when mean >= 12 and a simple method based upon the multiplication of uniform random variates otherwise. NB: The former is available only if _GLIBCXX_USE_C99_MATH_TR1 is defined.

Reference: Devroye, L. Non-Uniform Random Variates Generation. Springer-Verlag, New York, 1986, Ch. X, Sects. 3.3 & 3.4 (+ Errata!).

Definition at line 1311 of file bits/random.tcc.

References std::abs(), std::numeric_limits< _Tp >::epsilon(), std::log(), and std::numeric_limits< _Tp >::max().

## param() [1/2]

template<typename _IntType = int>

param_type std::poisson_distribution< _IntType >::param | ( |  | ) | const

inline

Returns the parameter set of the distribution.

Definition at line 4635 of file random.h.

## param() [2/2]

template<typename _IntType = int>

void std::poisson_distribution< _IntType >::param | ( | const param_type & | __param | ) |

inline

Sets the parameter set of the distribution.

Parameters

  __param | The new parameter set of the distribution.

Definition at line 4643 of file random.h.

## reset()

template<typename _IntType = int>

void std::poisson_distribution< _IntType >::reset | ( |  | ) |

inline

Resets the distribution state.

Definition at line 4621 of file random.h.

## Friends And Related Symbol Documentation

## operator<<

template<typename _IntType = int>
template<typename _IntType1, typename _CharT, typename _Traits>

std::basic_ostream< _CharT, _Traits > & operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const std::poisson_distribution< _IntType1 > & | __x )

friend

Inserts a poisson_distribution random number distribution `__x` into the output stream `__os`.

Parameters

  __os | An output stream.
  __x | A poisson_distribution random number distribution.

Returns
  The output stream with the state of `__x` inserted or in an error state.

## operator==

template<typename _IntType = int>

bool operator== | ( | const poisson_distribution< _IntType > & | __d1,
|  | const poisson_distribution< _IntType > & | __d2 )

friend

Return true if two Poisson distributions have the same parameters and the sequences that would be generated are equal.

Definition at line 4701 of file random.h.

## operator>>

template<typename _IntType = int>
template<typename _IntType1, typename _CharT, typename _Traits>

std::basic_istream< _CharT, _Traits > & operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | std::poisson_distribution< _IntType1 > & | __x )

friend

Extracts a poisson_distribution random number distribution `__x` from the input stream `__is`.

Parameters

  __is | An input stream.
  __x | A poisson_distribution random number generator engine.

Returns
  The input stream with `__x` extracted or in an error state.

The documentation for this class was generated from the following files:

- random.h
- bits/random.tcc